[BACK]Return to rc CVS log [TXT][DIR] Up to [local] / src / etc

Annotation of src/etc/rc, Revision 1.572

1.572   ! naddy       1: #      $OpenBSD: rc,v 1.571 2023/04/26 14:28:09 phessler Exp $
1.1       deraadt     2:
1.450     rpe         3: # System startup script run by init on autoboot or after single-user.
                      4: # Output and error are redirected to console by init, and the console is the
                      5: # controlling terminal.
1.454     rpe         6:
                      7: # Turn off Strict Bourne shell.
                      8: set +o sh
1.1       deraadt     9:
1.131     millert    10: # Subroutines (have to come first).
                     11:
1.456     rpe        12: # Strip in- and whole-line comments from a file.
                     13: # Strip leading and trailing whitespace if IFS is set.
                     14: # Usage: stripcom /path/to/file
1.131     millert    15: stripcom() {
1.456     rpe        16:        local _file=$1 _line
1.131     millert    17:
1.456     rpe        18:        [[ -s $_file ]] || return
                     19:
                     20:        while read _line ; do
                     21:                _line=${_line%%#*}
                     22:                [[ -n $_line ]] && print -r -- "$_line"
                     23:        done <$_file
1.131     millert    24: }
                     25:
1.456     rpe        26: # Update resource limits based on login.conf settings.
                     27: # Usage: update_limit -flag capability
1.265     millert    28: update_limit() {
1.456     rpe        29:        local _flag=$1          # ulimit flag
                     30:        local _cap=$2 _val      # login.conf capability and its value
                     31:        local _suffix
                     32:
1.490     otto       33:        for _suffix in {,-max,-cur}; do
1.456     rpe        34:                _val=$(getcap -f /etc/login.conf -s ${_cap}${_suffix} daemon 2>/dev/null)
                     35:                [[ -n $_val ]] || continue
                     36:                [[ $_val == infinity ]] && _val=unlimited
                     37:
                     38:                case $_suffix in
                     39:                -cur)   ulimit -S $_flag $_val
                     40:                        ;;
                     41:                -max)   ulimit -H $_flag $_val
                     42:                        ;;
                     43:                *)      ulimit $_flag $_val
                     44:                        return
                     45:                        ;;
                     46:                esac
1.265     millert    47:        done
                     48: }
                     49:
1.457     rpe        50: # Apply sysctl.conf(5) settings.
1.265     millert    51: sysctl_conf() {
1.520     bluhm      52:        # do not use a pipe as limits would only be applied to the subshell
                     53:        set -- $(stripcom /etc/sysctl.conf)
                     54:        while [[ $# > 0 ]] ; do
                     55:                sysctl "$1"
1.267     millert    56:
1.520     bluhm      57:                case "$1" in
1.265     millert    58:                kern.maxproc=*)
1.520     bluhm      59:                        update_limit -p maxproc
                     60:                        ;;
1.265     millert    61:                kern.maxfiles=*)
1.520     bluhm      62:                        update_limit -n openfiles
                     63:                        ;;
1.265     millert    64:                esac
1.520     bluhm      65:                shift
1.265     millert    66:        done
                     67: }
                     68:
1.457     rpe        69: # Apply mixerctl.conf(5) settings.
1.452     rpe        70: mixerctl_conf() {
1.457     rpe        71:        stripcom /etc/mixerctl.conf |
                     72:        while read _line; do
                     73:                mixerctl -q "$_line" 2>/dev/null
1.265     millert    74:        done
                     75: }
                     76:
1.457     rpe        77: # Apply wsconsctl.conf(5) settings.
1.452     rpe        78: wsconsctl_conf() {
1.457     rpe        79:        [[ -x /sbin/wsconsctl ]] || return
1.267     millert    80:
1.457     rpe        81:        stripcom /etc/wsconsctl.conf |
                     82:        while read _line; do
1.458     rpe        83:                eval "wsconsctl $_line"
1.267     millert    84:        done
                     85: }
                     86:
1.495     rpe        87: # Push the old seed into the kernel, create a future seed  and create a seed
                     88: # file for the boot-loader.
1.452     rpe        89: random_seed() {
1.427     bluhm      90:        dd if=/var/db/host.random of=/dev/random bs=65536 count=1 status=none
                     91:        chmod 600 /var/db/host.random
                     92:        dd if=/dev/random of=/var/db/host.random bs=65536 count=1 status=none
                     93:        dd if=/dev/random of=/etc/random.seed bs=512 count=1 status=none
                     94:        chmod 600 /etc/random.seed
1.312     djm        95: }
                     96:
1.450     rpe        97: # Populate net.inet.(tcp|udp).baddynamic with the contents of /etc/services so
                     98: # as to avoid randomly allocating source ports that correspond to well-known
1.451     rpe        99: # services.
1.459     rpe       100: # Usage: fill_baddynamic tcp|udp
1.452     rpe       101: fill_baddynamic() {
1.390     halex     102:        local _service=$1
1.318     djm       103:        local _sysctl="net.inet.${_service}.baddynamic"
1.459     rpe       104:
1.390     halex     105:        stripcom /etc/services |
                    106:        {
1.459     rpe       107:                _ban=
1.390     halex     108:                while IFS="     /" read _name _port _srv _junk; do
1.459     rpe       109:                        [[ $_srv == $_service ]] || continue
                    110:
                    111:                        _ban="${_ban:+$_ban,}+$_port"
                    112:
1.390     halex     113:                        # Flush before argv gets too long
1.459     rpe       114:                        if ((${#_ban} > 1024)); then
                    115:                                sysctl -q "$_sysctl=$_ban"
                    116:                                _ban=
1.390     halex     117:                        fi
                    118:                done
1.459     rpe       119:                [[ -n $_ban ]] && sysctl -q "$_sysctl=$_ban"
1.390     halex     120:        }
1.318     djm       121: }
                    122:
1.450     rpe       123: # Start daemon using the rc.d daemon control scripts.
1.451     rpe       124: # Usage: start_daemon daemon1 daemon2 daemon3
1.452     rpe       125: start_daemon() {
1.460     rpe       126:        local _daemon
                    127:
                    128:        for _daemon; do
                    129:                eval "_do=\${${_daemon}_flags}"
                    130:                [[ $_do != NO ]] && /etc/rc.d/${_daemon} start
1.353     robert    131:        done
                    132: }
                    133:
1.469     tim       134: # Generate keys for isakmpd, iked and sshd if they don't exist yet.
1.452     rpe       135: make_keys() {
1.460     rpe       136:        local _isakmpd_key=/etc/isakmpd/private/local.key
                    137:        local _isakmpd_pub=/etc/isakmpd/local.pub
                    138:        local _iked_key=/etc/iked/private/local.key
                    139:        local _iked_pub=/etc/iked/local.pub
1.572   ! naddy     140:        local _ssh_pub=/etc/ssh/ssh_host_ed25519_key.pub _show_ssh_fp=false
1.460     rpe       141:
                    142:        if [[ ! -f $_isakmpd_key ]]; then
1.560     tobhe     143:                echo -n "openssl: generating isakmpd RSA keys... "
1.460     rpe       144:                if openssl genrsa -out $_isakmpd_key 2048 >/dev/null 2>&1 &&
                    145:                        chmod 600 $_isakmpd_key &&
                    146:                        openssl rsa -out $_isakmpd_pub -in $_isakmpd_key \
                    147:                            -pubout >/dev/null 2>&1; then
1.373     deraadt   148:                        echo done.
                    149:                else
                    150:                        echo failed.
                    151:                fi
                    152:        fi
                    153:
1.460     rpe       154:        if [[ ! -f $_iked_key ]]; then
1.560     tobhe     155:                echo -n "openssl: generating iked ECDSA keys... "
                    156:                if openssl ecparam -genkey -name prime256v1 -out $_iked_key >/dev/null 2>&1 &&
                    157:                        chmod 600 $_iked_key &&
                    158:                        openssl ec -out $_iked_pub -in $_iked_key \
                    159:                            -pubout >/dev/null 2>&1; then
                    160:                        echo done.
                    161:                else
                    162:                        echo failed.
                    163:                fi
1.373     deraadt   164:        fi
                    165:
1.572   ! naddy     166:        [[ -f $_ssh_pub ]] || _show_ssh_fp=true
1.373     deraadt   167:        ssh-keygen -A
1.572   ! naddy     168:        $_show_ssh_fp && ssh-keygen -lf $_ssh_pub |
        !           169:            (read sz fp comm type && echo "sshd: $type $fp")
1.524     florian   170:
                    171:        if [[ ! -f /etc/soii.key ]]; then
1.525     rpe       172:                openssl rand -hex 16 > /etc/soii.key &&
1.524     florian   173:                    chmod 600 /etc/soii.key && sysctl -q \
                    174:                    "net.inet6.ip6.soiikey=$(</etc/soii.key)"
                    175:        fi
1.373     deraadt   176: }
                    177:
1.483     rpe       178: # Re-link libraries, placing the objects in a random order.
1.481     rpe       179: reorder_libs() {
1.521     rpe       180:        local _error=false _dkdev _liba _libas _mp _ro_list _tmpdir
1.522     rpe       181:        local _relink=/usr/share/relink
1.498     tb        182:
                    183:        [[ $library_aslr == NO ]] && return
                    184:
1.521     rpe       185:        # Skip if /usr/lib, /usr/libexec or /usr/share/relink are on nfs mounted
                    186:        # filesystems, otherwise record which ones are mounted read-only.
1.533     kn        187:        for _dkdev in $(df /usr/{lib,libexec} $_relink |
                    188:            sed '1d;s/ .*//' | sort -u); do
                    189:                _mp=$(mount -t ffs | grep "^$_dkdev") || return
                    190:                if [[ $_mp == *read-only* ]]; then
                    191:                        _ro_list="$_ro_list ${_mp%% *}"
1.521     rpe       192:                fi
                    193:        done
1.484     rpe       194:
1.569     deraadt   195:        echo 'reordering:'
1.523     tb        196:
1.556     jsg       197:        # Remount the (read-only) filesystems in _ro_list as read-write.
1.521     rpe       198:        for _mp in $_ro_list; do
                    199:                if ! mount -u -w $_mp; then
1.565     cheloha   200:                        echo '(failed).'
1.481     rpe       201:                        return
                    202:                fi
1.521     rpe       203:        done
1.509     tb        204:
                    205:        # Only choose the latest version of the libraries.
1.522     rpe       206:        for _liba in $_relink/usr/lib/lib{c,crypto}; do
1.513     zhuk      207:                _libas="$_libas $(ls $_liba.so.+([0-9.]).a | sort -rV | head -1)"
1.509     tb        208:        done
1.481     rpe       209:
1.522     rpe       210:        for _liba in $_relink/usr/libexec/ld.so.a $_libas; do
                    211:                _tmpdir=$(mktemp -dq $_relink/_rebuild.XXXXXXXXXXXX) &&
1.517     rpe       212:                (
                    213:                set -o errexit
1.534     kn        214:                _install='install -F -o root -g bin -m 0444'
1.517     rpe       215:                _lib=${_liba##*/}
                    216:                _lib=${_lib%.a}
1.522     rpe       217:                _lib_dir=${_liba#$_relink}
1.523     tb        218:                _lib_dir=${_lib_dir%/*}
1.517     rpe       219:                cd $_tmpdir
                    220:                ar x $_liba
                    221:                if [[ $_lib == ld.so ]]; then
1.566     florian   222:                        echo " $_lib"
1.537     guenther  223:                        args="-g -x -e _dl_start \
1.517     rpe       224:                            --version-script=Symbols.map --shared -Bsymbolic \
1.537     guenther  225:                            --no-undefined"
                    226:                        [[ -f ld.script ]] && args="$args -T ld.script"
                    227:                        ld $args -o ld.so.test $(ls *.o | sort -R)
1.517     rpe       228:                        chmod u+x test-ld.so
                    229:                        [[ $(./test-ld.so ok) == './test-ld.so: ok!' ]]
                    230:                        $_install /usr/libexec/ld.so /usr/libexec/ld.so.save
1.521     rpe       231:                        $_install ld.so.test $_lib_dir/ld.so
1.517     rpe       232:                else
1.566     florian   233:                        echo " ${_lib%%.*}"
1.541     naddy     234:                        cc -shared -o $_lib $(ls *.so | sort -R) $(<.ldadd)
1.475     deraadt   235:                        [[ -s $_lib ]] && file $_lib | fgrep -q 'shared object'
                    236:                        LD_BIND_NOW=1 LD_LIBRARY_PATH=$_tmpdir awk 'BEGIN {exit 0}'
1.500     deraadt   237:                        LD_BIND_NOW=1 LD_LIBRARY_PATH=$_tmpdir openssl \
                    238:                            x509 -in /etc/ssl/cert.pem -out /dev/null
1.521     rpe       239:                        $_install $_lib $_lib_dir/$_lib
1.517     rpe       240:                fi
1.485     rpe       241:                ) || { _error=true; break; }
1.475     deraadt   242:        done
1.481     rpe       243:
1.569     deraadt   244:        for _bin in $_relink/usr/sbin/sshd; do
                    245:                _tmpdir=$(mktemp -dq $_relink/_rebuild.XXXXXXXXXXXX) &&
                    246:                (
                    247:                set -o errexit
                    248:                cd $_tmpdir
                    249:                _binn=${_bin##*/}
                    250:                _bint=${_bin}/${_binn}.tar
                    251:                if [[ -f $_bint ]]; then
                    252:                        echo " $_binn"
                    253:                        tar xf $_bint
                    254:                        make -f Makefile.relink relink >/dev/null 2>&1
                    255:                fi
                    256:                ) || { _error=true; break; }
                    257:        done
1.570     asou      258:
1.522     rpe       259:        rm -rf $_relink/_rebuild.*
1.485     rpe       260:
1.481     rpe       261:        # Restore previous mount state if it was changed.
1.521     rpe       262:        for _mp in $_ro_list; do
                    263:                mount -u -r $_mp || _error=true
                    264:        done
1.482     deraadt   265:
1.485     rpe       266:        if $_error; then
1.565     cheloha   267:                echo '(failed).'
1.485     rpe       268:        else
1.565     cheloha   269:                echo '.'
1.485     rpe       270:        fi
1.475     deraadt   271: }
                    272:
1.566     florian   273: # Read output of reorder_libs co-process and output on console.
                    274: wait_reorder_libs() {
                    275:        local _line
1.568     kn        276:
                    277:        [[ $library_aslr == NO ]] && return
1.567     kn        278:
1.566     florian   279:        while IFS= read -p _line; do
                    280:                echo -n "$_line"
                    281:        done
                    282:        echo
                    283: }
                    284:
1.483     rpe       285: # Run rc.* script and email output to root.
                    286: # Usage: run_upgrade_script firsttime|sysmerge
1.477     ajacouto  287: run_upgrade_script() {
                    288:        local _suffix=$1
1.491     rpe       289:
1.477     ajacouto  290:        [[ -n $_suffix ]] || return 1
1.491     rpe       291:
1.477     ajacouto  292:        if [[ -f /etc/rc.$_suffix ]]; then
1.516     ajacouto  293:                echo "running rc.$_suffix"
1.477     ajacouto  294:                mv /etc/rc.$_suffix /etc/rc.$_suffix.run
                    295:                . /etc/rc.$_suffix.run 2>&1 | tee /dev/tty |
                    296:                        mail -Es "$(hostname) rc.$_suffix output" root >/dev/null
                    297:        fi
                    298:        rm -f /etc/rc.$_suffix.run
                    299: }
                    300:
1.462     rpe       301: # Check filesystems, optionally by using a fsck(8) flag.
                    302: # Usage: do_fsck [-flag]
1.452     rpe       303: do_fsck() {
1.462     rpe       304:        fsck -p "$@"
1.429     claudio   305:        case $? in
1.462     rpe       306:        0)      ;;
                    307:        2)      exit 1
1.429     claudio   308:                ;;
1.462     rpe       309:        4)      echo "Rebooting..."
1.429     claudio   310:                reboot
                    311:                echo "Reboot failed; help!"
                    312:                exit 1
                    313:                ;;
1.462     rpe       314:        8)      echo "Automatic file system check failed; help!"
1.429     claudio   315:                exit 1
                    316:                ;;
1.462     rpe       317:        12)     echo "Boot interrupted."
1.429     claudio   318:                exit 1
                    319:                ;;
1.462     rpe       320:        130)    # Interrupt before catcher installed.
1.429     claudio   321:                exit 1
                    322:                ;;
1.462     rpe       323:        *)      echo "Unknown error; help!"
1.429     claudio   324:                exit 1
                    325:                ;;
                    326:        esac
                    327: }
                    328:
1.450     rpe       329: # End subroutines.
1.131     millert   330:
1.1       deraadt   331: stty status '^T'
                    332:
1.450     rpe       333: # Set shell to ignore SIGINT (2), but not children; shell catches SIGQUIT (3)
                    334: # and returns to single user after fsck.
1.1       deraadt   335: trap : 2
1.450     rpe       336: trap : 3       # Shouldn't be needed.
1.1       deraadt   337:
1.463     rpe       338: export HOME=/
                    339: export INRC=1
                    340: export PATH=/sbin:/bin:/usr/sbin:/usr/bin
1.544     deraadt   341:
                    342: # /etc/myname contains my symbolic name.
                    343: if [[ -f /etc/myname ]]; then
                    344:        hostname "$(stripcom /etc/myname)"
                    345: fi
1.395     deraadt   346:
1.450     rpe       347: # Must set the domainname before rc.conf, so YP startup choices can be made.
1.563     miod      348: if [[ -s /etc/defaultdomain && -z "$(sysctl -n kern.domainname)" ]]; then
1.463     rpe       349:        domainname "$(stripcom /etc/defaultdomain)"
1.395     deraadt   350: fi
1.108     deraadt   351:
1.495     rpe       352: # Get local functions from rc.subr to load rc.conf into scope.
1.428     robert    353: FUNCS_ONLY=1 . /etc/rc.d/rc.subr
                    354: _rc_parse_conf
1.343     robert    355:
1.495     rpe       356: # If executed with the 'shutdown' parameter by the halt, reboot or shutdown:
                    357: # - update seed files
                    358: # - execute the rc.d scripts specified by $pkg_scripts in reverse order
                    359: # - bring carp interfaces down gracefully
1.463     rpe       360: if [[ $1 == shutdown ]]; then
1.525     rpe       361:        if echo 2>/dev/null >>/var/db/host.random ||
1.437     bluhm     362:            echo 2>/dev/null >>/etc/random.seed; then
                    363:                random_seed
                    364:        else
                    365:                echo warning: cannot write random seed to disk
                    366:        fi
1.416     rpe       367:
1.469     tim       368:        # If we are in secure level 0, assume single user mode.
1.463     rpe       369:        if (($(sysctl -n kern.securelevel) == 0)); then
                    370:                echo 'single user: not running shutdown scripts'
                    371:        else
1.514     rpe       372:                set -A _d -- $pkg_scripts
                    373:                _i=${#_d[*]}
                    374:                if ((_i)); then
1.413     deraadt   375:                        echo -n 'stopping package daemons:'
1.514     rpe       376:                        while ((--_i >= 0)); do
                    377:                                [[ -x /etc/rc.d/${_d[_i]} ]] &&
                    378:                                        /etc/rc.d/${_d[_i]} stop
1.413     deraadt   379:                        done
1.527     sthen     380:                        echo '.'
                    381:                fi
                    382:
                    383:                if /etc/rc.d/vmd check > /dev/null; then
                    384:                        echo -n 'stopping VMs'
                    385:                        /etc/rc.d/vmd stop > /dev/null
1.413     deraadt   386:                        echo '.'
                    387:                fi
                    388:
1.463     rpe       389:                [[ -f /etc/rc.shutdown ]] && sh /etc/rc.shutdown
1.413     deraadt   390:        fi
1.240     mcbride   391:
1.463     rpe       392:        ifconfig | while read _if _junk; do
1.474     rpe       393:                [[ $_if == carp+([0-9]): ]] && ifconfig ${_if%:} down
1.413     deraadt   394:        done
1.246     mcbride   395:
1.108     deraadt   396:        exit 0
1.1       deraadt   397: fi
1.98      jakob     398:
1.540     deraadt   399: # If bootblocks failed to give us random, try to cause some churn
                    400: (dmesg; sysctl hw.{uuid,serialno,sensors} ) >/dev/random 2>&1
                    401:
1.482     deraadt   402: # Add swap block-devices.
1.172     miod      403: swapctl -A -t blk
1.170     deraadt   404:
1.495     rpe       405: # Run filesystem check unless a /fastboot file exists.
1.463     rpe       406: if [[ -e /fastboot ]]; then
1.1       deraadt   407:        echo "Fast boot: skipping disk checks."
1.463     rpe       408: elif [[ $1 == autoboot ]]; then
1.1       deraadt   409:        echo "Automatic boot in progress: starting file system checks."
1.429     claudio   410:        do_fsck
1.1       deraadt   411: fi
                    412:
1.495     rpe       413: # From now on, allow user to interrupt (^C) the boot process.
1.1       deraadt   414: trap "echo 'Boot interrupted.'; exit 1" 3
                    415:
1.495     rpe       416: # Unmount all filesystems except root.
1.1       deraadt   417: umount -a >/dev/null 2>&1
1.495     rpe       418:
                    419: # Mount all filesystems except those of type NFS and VND.
1.303     grunk     420: mount -a -t nonfs,vnd
1.177     deraadt   421:
1.495     rpe       422: # Re-mount the root filesystem read/writeable. (root on nfs requires this,
                    423: # others aren't hurt.)
                    424: mount -uw /
1.499     deraadt   425: chmod og-rwx /bsd
1.503     deraadt   426: ln -fh /bsd /bsd.booted
1.495     rpe       427:
                    428: rm -f /fastboot
                    429:
1.505     tedu      430: # Set flags on ttys.
1.1       deraadt   431: ttyflags -a
1.77      angelos   432:
1.464     rpe       433: # Set keyboard encoding.
                    434: if [[ -x /sbin/kbd && -s /etc/kbdtype ]]; then
1.541     naddy     435:        kbd "$(</etc/kbdtype)"
1.252     mcbride   436: fi
                    437:
1.279     deraadt   438: wsconsctl_conf
                    439:
1.464     rpe       440: # Set initial temporary pf rule set.
                    441: if [[ $pf != NO ]]; then
1.511     rpe       442:        RULES="
1.510     rpe       443:        block all
                    444:        pass on lo0
                    445:        pass in proto tcp from any to any port ssh keep state
                    446:        pass out proto { tcp, udp } from any to any port domain keep state
                    447:        pass out inet proto icmp all icmp-type echoreq keep state
                    448:        pass out inet proto udp from any port bootpc to any port bootps
1.511     rpe       449:        pass in inet proto udp from any port bootps to any port bootpc"
1.510     rpe       450:
1.257     grange    451:        if ifconfig lo0 inet6 >/dev/null 2>&1; then
1.510     rpe       452:                RULES="$RULES
                    453:                pass out inet6 proto icmp6 all icmp6-type neighbrsol
1.571     phessler  454:                pass inet6 proto icmp6 all icmp6-type neighbradv no state
1.510     rpe       455:                pass out inet6 proto icmp6 all icmp6-type routersol
                    456:                pass in inet6 proto icmp6 all icmp6-type routeradv
                    457:                pass out inet6 proto udp from any port dhcpv6-client to any port dhcpv6-server
                    458:                pass in inet6 proto udp from any port dhcpv6-server to any port dhcpv6-client"
1.257     grange    459:        fi
1.510     rpe       460:
                    461:        RULES="$RULES
                    462:        pass in proto carp keep state (no-sync)
                    463:        pass out proto carp !received-on any keep state (no-sync)"
                    464:
1.545     naddy     465:        if (($(sysctl -n vfs.mounts.nfs 2>/dev/null)+0 > 0)); then
1.511     rpe       466:                # Don't kill NFS.
1.510     rpe       467:                RULES="set reassemble yes no-df
                    468:                $RULES
                    469:                pass in proto { tcp, udp } from any port { sunrpc, nfsd } to any
                    470:                pass out proto { tcp, udp } from any to any port { sunrpc, nfsd } !received-on any"
1.474     rpe       471:        fi
1.511     rpe       472:
1.464     rpe       473:        print -- "$RULES" | pfctl -f -
1.269     dhartmei  474:        pfctl -e
1.176     kjell     475: fi
1.318     djm       476:
                    477: fill_baddynamic udp
                    478: fill_baddynamic tcp
1.176     kjell     479:
1.267     millert   480: sysctl_conf
1.260     jsg       481:
1.557     florian   482: mount -s /var >/dev/null 2>&1          # cannot be on NFS
                    483: mount -s /var/log >/dev/null 2>&1      # cannot be on NFS
1.564     deraadt   484: mount -s /usr >/dev/null 2>&1          # if NFS, fstab must use IP address
1.557     florian   485:
1.566     florian   486: reorder_libs 2>&1 |&
                    487:
1.557     florian   488: start_daemon slaacd dhcpleased resolvd >/dev/null 2>&1
1.501     florian   489:
1.1       deraadt   490: echo 'starting network'
1.464     rpe       491:
                    492: # Set carp interlock by increasing the demotion counter.
                    493: # Prevents carp from preempting until the system is booted.
1.536     tedu      494: ifconfig -g carp carpdemote 128
1.464     rpe       495:
1.439     ajacouto  496: sh /etc/netstart
1.542     deraadt   497:
1.557     florian   498: start_daemon unwind >/dev/null 2>&1
1.542     deraadt   499:
1.550     deraadt   500: random_seed
                    501:
1.566     florian   502: wait_reorder_libs
1.550     deraadt   503:
1.450     rpe       504: # Load pf rules and bring up pfsync interface.
1.464     rpe       505: if [[ $pf != NO ]]; then
                    506:        if [[ -f /etc/pf.conf ]]; then
1.449     ajacouto  507:                pfctl -f /etc/pf.conf
1.309     mpf       508:        fi
1.464     rpe       509:        if [[ -f /etc/hostname.pfsync0 ]]; then
1.435     deraadt   510:                sh /etc/netstart pfsync0
1.367     deraadt   511:        fi
1.176     kjell     512: fi
1.29      deraadt   513:
1.450     rpe       514: # Clean up left-over files.
1.492     jca       515: rm -f /etc/nologin /var/spool/lock/LCK.*
1.247     henning   516: (cd /var/run && { rm -rf -- *; install -c -m 664 -g utmp /dev/null utmp; })
1.196     beck      517: (cd /var/authpf && rm -rf -- *)
1.96      alex      518:
1.495     rpe       519: # Save a copy of the boot messages.
                    520: dmesg >/var/run/dmesg.boot
1.55      deraadt   521:
1.373     deraadt   522: make_keys
                    523:
1.379     deraadt   524: echo -n 'starting early daemons:'
1.543     tedu      525: start_daemon syslogd ldattach pflogd nsd unbound ntpd
1.429     claudio   526: start_daemon iscsid isakmpd iked sasyncd ldapd npppd
1.353     robert    527: echo '.'
1.280     hshoexer  528:
1.450     rpe       529: # Load IPsec rules.
1.464     rpe       530: if [[ $ipsec != NO && -f /etc/ipsec.conf ]]; then
                    531:        ipsecctl -f /etc/ipsec.conf
1.40      provos    532: fi
1.1       deraadt   533:
1.379     deraadt   534: echo -n 'starting RPC daemons:'
1.562     deraadt   535: start_daemon portmap
1.464     rpe       536: if [[ -n $(domainname) ]]; then
1.562     deraadt   537:        start_daemon ypldap ypserv ypbind
1.376     deraadt   538: fi
1.399     dlg       539: start_daemon mountd nfsd lockd statd amd
1.1       deraadt   540: echo '.'
1.58      deraadt   541:
1.464     rpe       542: # Check and mount remaining file systems and enable additional swap.
1.278     otto      543: mount -a
1.172     miod      544: swapctl -A -t noblk
1.429     claudio   545: do_fsck -N
                    546: mount -a -N
1.1       deraadt   547:
1.549     deraadt   548: # Build kvm(3) and /dev databases.
                    549: kvm_mkdb
                    550: dev_mkdb
                    551:
1.450     rpe       552: # /var/crash should be a directory or a symbolic link to the crash directory
                    553: # if core dumps are to be saved.
1.464     rpe       554: if [[ -d /var/crash ]]; then
                    555:        savecore $savecore_flags /var/crash
1.487     rpe       556: fi
                    557:
                    558: # Store ACPI tables in /var/db/acpi to be used by sendbug(1).
                    559: if [[ -x /usr/sbin/acpidump ]]; then
1.530     kettenis  560:        acpidump -q -o /var/db/acpi/
1.90      art       561: fi
                    562:
1.464     rpe       563: if [[ $check_quotas == YES ]]; then
1.41      downsj    564:        echo -n 'checking quotas:'
                    565:        quotacheck -a
                    566:        echo ' done.'
                    567:        quotaon -a
                    568: fi
1.464     rpe       569:
                    570: # Set proper permission for the tty device files.
1.101     deraadt   571: chmod 666 /dev/tty[pqrstuvwxyzPQRST]*
1.226     millert   572: chown root:wheel /dev/tty[pqrstuvwxyzPQRST]*
1.1       deraadt   573:
1.495     rpe       574: # Check for the password temp/lock file.
1.467     rpe       575: if [[ -f /etc/ptmp ]]; then
1.1       deraadt   576:        logger -s -p auth.err \
1.376     deraadt   577:            'password file may be incorrect -- /etc/ptmp exists'
1.32      deraadt   578: fi
                    579:
1.49      millert   580: echo clearing /tmp
                    581:
1.450     rpe       582: # Prune quickly with one rm, then use find to clean up /tmp/[lqv]*
                    583: # (not needed with mfs /tmp, but doesn't hurt there...).
1.444     deraadt   584: (cd /tmp && rm -rf [a-km-pr-uw-zA-Z]*)
1.339     sthen     585: (cd /tmp &&
1.443     millert   586:     find . -maxdepth 1 ! -name . ! -name lost+found ! -name quota.user \
1.444     deraadt   587:        ! -name quota.group ! -name vi.recover -execdir rm -rf -- {} \;)
1.373     deraadt   588:
1.462     rpe       589: # Create Unix sockets directories for X if needed and make sure they have
                    590: # correct permissions.
                    591: [[ -d /usr/X11R6/lib ]] && mkdir -m 1777 /tmp/.{X11,ICE}-unix
1.203     hugh      592:
1.467     rpe       593: [[ -f /etc/rc.securelevel ]] && sh /etc/rc.securelevel
                    594:
1.450     rpe       595: # rc.securelevel did not specifically set -1 or 2, so select the default: 1.
1.467     rpe       596: (($(sysctl -n kern.securelevel) == 0)) && sysctl kern.securelevel=1
                    597:
1.1       deraadt   598:
1.450     rpe       599: # Patch /etc/motd.
1.467     rpe       600: if [[ ! -f /etc/motd ]]; then
1.34      deraadt   601:        install -c -o root -g wheel -m 664 /dev/null /etc/motd
                    602: fi
1.467     rpe       603: if T=$(mktemp /tmp/_motd.XXXXXXXXXX); then
1.451     rpe       604:        sysctl -n kern.version | sed 1q >$T
1.494     schwarze  605:        sed -n '/^$/,$p' </etc/motd >>$T
1.102     millert   606:        cmp -s $T /etc/motd || cp $T /etc/motd
                    607:        rm -f $T
                    608: fi
1.34      deraadt   609:
1.467     rpe       610: if [[ $accounting == YES ]]; then
                    611:        [[ ! -f /var/account/acct ]] && touch /var/account/acct
                    612:        echo 'turning on accounting'
                    613:        accton /var/account/acct
1.1       deraadt   614: fi
                    615:
1.467     rpe       616: if [[ -x /sbin/ldconfig ]]; then
1.115     deraadt   617:        echo 'creating runtime link editor directory cache.'
1.471     rpe       618:        [[ -d /usr/local/lib ]] && shlib_dirs="/usr/local/lib $shlib_dirs"
1.467     rpe       619:        [[ -d /usr/X11R6/lib ]] && shlib_dirs="/usr/X11R6/lib $shlib_dirs"
1.115     deraadt   620:        ldconfig $shlib_dirs
1.231     millert   621: fi
                    622:
1.451     rpe       623: echo 'preserving editor files.'; /usr/libexec/vi.recover
1.244     markus    624:
1.477     ajacouto  625: # If rc.sysmerge exists, run it just once, and make sure it is deleted.
                    626: run_upgrade_script sysmerge
                    627:
1.353     robert    628: echo -n 'starting network daemons:'
1.555     claudio   629: start_daemon ldomd sshd snmpd ldpd ripd ospfd ospf6d bgpd ifstated
1.529     florian   630: start_daemon relayd dhcpd dhcrelay mrouted dvmrpd radiusd eigrpd route6d
1.559     claudio   631: start_daemon rad hostapd lpd smtpd slowcgi bgplgd httpd ftpd
1.461     sthen     632: start_daemon ftpproxy ftpproxy6 tftpd tftpproxy identd inetd rarpd bootparamd
1.488     reyk      633: start_daemon rbootd mopd vmd spamd spamlogd sndiod
1.377     robert    634: echo '.'
1.335     deraadt   635:
1.450     rpe       636: # If rc.firsttime exists, run it just once, and make sure it is deleted.
1.477     ajacouto  637: run_upgrade_script firsttime
1.352     ajacouto  638:
1.450     rpe       639: # Run rc.d(8) scripts from packages.
1.467     rpe       640: if [[ -n $pkg_scripts ]]; then
1.352     ajacouto  641:        echo -n 'starting package daemons:'
1.467     rpe       642:        for _daemon in $pkg_scripts; do
                    643:                if [[ -x /etc/rc.d/$_daemon ]]; then
                    644:                        start_daemon $_daemon
1.410     espie     645:                else
1.467     rpe       646:                        echo -n " ${_daemon}(absent)"
1.410     espie     647:                fi
1.352     ajacouto  648:        done
                    649:        echo '.'
                    650: fi
1.17      deraadt   651:
1.467     rpe       652: [[ -f /etc/rc.local ]] && sh /etc/rc.local
1.73      millert   653:
1.495     rpe       654: # Disable carp interlock.
1.536     tedu      655: ifconfig -g carp -carpdemote 128
1.286     mcbride   656:
1.379     deraadt   657: mixerctl_conf
1.467     rpe       658:
1.379     deraadt   659: echo -n 'starting local daemons:'
1.493     matthieu  660: start_daemon apmd sensorsd hotplugd watchdogd cron wsmoused xenodm
1.73      millert   661: echo '.'
1.502     rpe       662:
1.515     rpe       663: # Re-link the kernel, placing the objects in a random order.
                    664: # Replace current with relinked kernel and inform root about it.
                    665: /usr/libexec/reorder_kernel &
1.1       deraadt   666:
                    667: date
                    668: exit 0